const { CatalogBuilder } = require('gettext-extractor/dist/builder');
const ensureSingleLine = require('./ensureSingleLine.js');

module.exports = class SingleLineCatalogBuilder extends CatalogBuilder {
  constructor(builderInstance) {
    super(builderInstance.stats);
    for (const prop in builderInstance.contexts) {
      if (builderInstance.contexts.hasOwnProperty(prop)) {
        throw new Error('Make sure you run ensureSingleLineMessages before extracting any strings');
      }
    }
  }

  addMessage(message) {
    if (message.text) {
      message.text = ensureSingleLine(message.text);
    }
    if (message.textPlural) {
      message.textPlural = ensureSingleLine(message.textPlural);
    }
    super.addMessage(message);
  }
};
